'use strict';

exports.__esModule = true;

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _lodashObject = require('lodash/object');

var _placeholders = require('./placeholders');

var _placeholders2 = _interopRequireDefault(_placeholders);

var ReactFiller = (function (_React$Component) {
  _inherits(ReactFiller, _React$Component);

  function ReactFiller() {
    var _this = this;

    _classCallCheck(this, ReactFiller);

    _React$Component.apply(this, arguments);

    this.state = {
      ready: this.props.ready
    };

    this.isReady = function () {
      return _this.props.firstLaunchOnly ? _this.state.ready : _this.props.ready;
    };

    this.getFiller = function () {
      var _props = _this.props;
      var type = _props.type;
      var customPlaceholder = _props.customPlaceholder;

      if (customPlaceholder) {
        return customPlaceholder;
      }

      var Placeholder = _placeholders2['default'][type];
      var props = _lodashObject.omit(_this.props, ['children', 'ready', 'firstLaunchOnly', 'type']);

      return _react2['default'].createElement(Placeholder, props);
    };
  }

  ReactFiller.prototype.render = function render() {
    return this.isReady() ? this.props.children : this.getFiller();
  };

  ReactFiller.prototype.componentWillReceiveProps = function componentWillReceiveProps(nextProps) {
    if (!this.state.ready) {
      this.setState({
        ready: nextProps.ready
      });
    }
  };

  _createClass(ReactFiller, null, [{
    key: 'propTypes',
    value: {
      children: _react2['default'].PropTypes.oneOfType([_react2['default'].PropTypes.node, _react2['default'].PropTypes.element]).isRequired,
      ready: _react2['default'].PropTypes.bool.isRequired,
      firstLaunchOnly: _react2['default'].PropTypes.bool,
      type: _react2['default'].PropTypes.oneOf(['text', 'media', 'textRow', 'rect', 'round']),
      rows: _react2['default'].PropTypes.number,
      color: _react2['default'].PropTypes.string,
      customPlaceholder: _react2['default'].PropTypes.oneOfType([_react2['default'].PropTypes.node, _react2['default'].PropTypes.element])
    },
    enumerable: true
  }, {
    key: 'defaultProps',
    value: {
      type: 'text',
      color: '#CDCDCD'
    },
    enumerable: true
  }]);

  return ReactFiller;
})(_react2['default'].Component);

exports['default'] = ReactFiller;
module.exports = exports['default'];