'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _TextRow = require('./TextRow');

var _TextRow2 = _interopRequireDefault(_TextRow);

var widths = [97, 100, 94, 90, 98, 95, 98, 40];

var TextBlock = (function (_React$Component) {
  _inherits(TextBlock, _React$Component);

  function TextBlock() {
    var _this = this;

    _classCallCheck(this, TextBlock);

    _React$Component.apply(this, arguments);

    this.getRowStyle = function (i) {
      var _props = _this.props;
      var rows = _props.rows;
      var color = _props.color;

      var style = {
        backgroundColor: color,
        maxHeight: 100 / (rows * 2 - 1) + '%'
      };

      if (i % 2 === 0) {
        style.width = widths[(i / 2 + widths.length) % widths.length] + '%';
      }

      return style;
    };

    this.getRows = function () {
      var rows = _this.props.rows * 2 - 1;
      var range = Array.apply(null, { length: rows });
      return range.map(function (x, i) {
        return _react2['default'].createElement(_TextRow2['default'], { style: _this.getRowStyle(i), invisible: i % 2 > 0, key: i });
      });
    };
  }

  TextBlock.prototype.render = function render() {
    var _props2 = this.props;
    var style = _props2.style;
    var className = _props2.className;

    return _react2['default'].createElement(
      'div',
      { className: _classnames2['default']('text-block', className), style: _extends({}, style, { width: '100%' }) },
      this.getRows()
    );
  };

  _createClass(TextBlock, null, [{
    key: 'propTypes',
    value: {
      rows: _react2['default'].PropTypes.number.isRequired,
      color: _react2['default'].PropTypes.string.isRequired,
      style: _react2['default'].PropTypes.object,
      className: _react2['default'].PropTypes.string
    },
    enumerable: true
  }]);

  return TextBlock;
})(_react2['default'].Component);

exports['default'] = TextBlock;
module.exports = exports['default'];